package iSATLibrary;

import java.util.BitSet;

public interface ISatSolver {
	
	// method for ipasir
	public String getSignature();
	public ISatSolver init();
	public void release();
	public void add(int lit_or_zero);
	public void assume(int lit);
	public int solve();
	public int val(int lit);
	public int failed(int lit);
	public void setTerminate(int value);
	
	// method for isatlib
	public String getSolverName();
	public void setVerbosity(int verbosity);
	public int getVars();
	public int getClauses();
	public void newVar(int howmany);
	public void addClause(int[] clause);
	public void addClauses(int[][] clauses);
	public void addAssumptions(int[] assumptions);
	public int solve(int[] assumptions);
	public void addBlockingClause();
	public void addBlockingClause(int[] clause);
	public int addPB(int[] weights, int[] literals, int k, boolean isgeq);
	public int addPBWithAssumption(int[] weights, int[] literals, int k, boolean isgeq, int assumption);
	public int addAtMost(int[] literals, int k);
	public int addAtMostWithAssumption(int[] literals, int k, int assumption);
	public int addAtLeast(int[] literals, int k);
	public int addAtLeastWithAssumption(int[] literals, int k, int assumption);
	public int addExactly(int[] literals, int k);
	public int addExactlyWithAssumption(int[] literals, int k, int assumption);
	public void setFrozen(int lit);
	public boolean isEliminated(int lit);
	public BitSet getModel();
	public int[] getIntModel();
	public int[] getFailed(int[] literals);
	public void outputModel();
	public double getTime();

	public void addNormalizedClause(int[] clause);
	public void done();
	public void setVars(int count);
	public int[] getMUS();
}
